﻿using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SfDataGridDemo
{
    public class ViewModel : NotificationObject
    {
        public static bool isAnyColumnHighlighted = false;

        #region Constructor

        public ViewModel()
        {
            this.Employees = GetEmployeesDetails(27);
        }

        #endregion

        #region Properties

        private ObservableCollection<BusinessObjects> employees;
        public ObservableCollection<BusinessObjects> Employees
        {
            get
            {
                return employees;
            }
            set
            {
                employees = value;
                RaisePropertyChanged("Employees");
            }
        }

        private ObservableCollection<string> _comboBoxItemsSource;

        public ObservableCollection<string> ComboBoxItemsSource
        {
            get { return _comboBoxItemsSource; }
            set { _comboBoxItemsSource = value; RaisePropertyChanged("ComboBoxItemsSource"); }
        }

        int number = 0;

        #endregion

        #region Generate Data

        public ObservableCollection<BusinessObjects> GetEmployeesDetails(int count)
        {
            if (ComboBoxItemsSource == null)
            {
                _comboBoxItemsSource = new ObservableCollection<string>();
                for (int i = 0; i < countries.Count(); i++)
                {
                    _comboBoxItemsSource.Add(countries[i]);
                }
            }
            var employees = new ObservableCollection<BusinessObjects>();
            for (int i = 1; i < count; i++)
            {
                employees.Add(GetEmployee(i));
                number++;
            }
            return employees;
        }

        public BusinessObjects GetEmployee(int i)
        {
            number = number < 10 ? number++ : 1;
            return new BusinessObjects()
            {
                EmployeeName = names[i],
                EmployeeArea = ComboBoxItemsSource.ElementAt(number),
                EmployeeGender = i == 26 ? "Female" : "Male",
                EmployeeID = i,
                IsChecked=false,
                Salary=i*3000,
                JoiningDate = DateTime.Now.AddDays(i)
            };
        }

        #endregion

        private string[] names = new string[]
        {
            "Robert",
             "John",
             "clarke",
             "Mathews",
             "Smith",
             "Martin",
             "Inigo",
             "Antony",
             "Micheal",
             "Anderson",
             "Alastair",
             "Kevin",
             "Alex",
             "Hussain",
             "Hughes",
             "Andrews",    
             "Irfan",
             "Mohammed",
             "Ahmed",
             "Bichel",
             "Martin",
             "Austin",
             "Prince",
             "Christian",
             "David",
             "Steven",
            "Johnson",
            "Stewart",
            "Richards",
            "Morgan"
        };

        private string[] countries = new string[]
        {
            "Brazil",
             "Germany",
             "France",
             "Japan",
             "China",
             "Ireland",
             "Argentina",
             "England",
             "Brazil",
             "Germany",
             "France",
             "Japan",
             "China",
             "Ireland",
             "Argentina",
             "England",
             "Brazil",
             "Germany",
             "France",
             "Japan",
             "China",
             "Ireland",
             "Argentina",
             "England"
        };
    }
}
